
let room;
let localStream;
let globalActiveList = [];
let newGlobalActiveList = [];
let camList;
let micList;
let speakerList;

function joinRoomJs(data) {
  console.log(data);
  getDevices(data);
}

function getDevices(data) {
  EnxRtc.getDevices(function (response) {
    console.log('Pankaj device: ', response);
    if (response.result === 0) {   // success
      /* Device Lists in response.devices */
      camList = response.devices.cam;
      micList = response.devices.mic;
      speakerList = response.devices.speaker;
      console.log(camList);
      joinRoom(data)
    }
    else if (response.result === 1144) { // Error case

    }
  });
}

function getAllDevicesList() {
  let devices = [{ camList: camList, speakerList: speakerList, micList: micList }]
  const jsonData = JSON.stringify(devices);
  // Invoke the Dart callback function with the JSON data
  window.getDevicesCallback(jsonData);

}

function joinRoom(data) {
  var VideoSize = {
    "HD": [320, 180, 1280, 720],
    "SD": [320, 180, 640, 480],
    "LD": [80, 45, 640, 360]
  };

  var StreamOpt = {
    video: true,
    audio: true,
    data: true,
    videoSize: VideoSize.HD,
    attributes: { name: "XX" }
  };

  var reConnectOpt = {
    "allow_recnnect": true,
    "number_of_attempts": 3,
    "timeout_interval": 10000
  };
  var PlayerOpt = {
    player: {
      'height': '150px',
      'width': '100%',
      'minHeight': 'inherit',
      'minWidth': 'inherit'
    },
    toolbar: {
      displayMode: false,
      branding: {
        display: false
      }
    }
  };


  localStream = EnxRtc.joinRoom(data.token, data.localInfo, function (success, error) {
    if (error && error != null) {
      // Look for error.type and error.msg.name to handle Exception
      if (error.type == "media-access-denied") {
        // Media Media Inaccessibility
        return;
      }
    }

    if (success && success != null) {

      if (localStream && localStream.stream) {

        if (activeDivMap.has(0)) {
          createNativeViewDiv(activeDivMap.get(0));
        }

      }
      room = success.room;

      console.log(success);
      //parseResponse(success.room);

      let roomData = {
        role: room.me.role,
        roomId: room.roomID
      }

      let data = parseData(success.room);
      var jsonString = JSON.stringify(roomData);

      //dartCallback({ methodName: 'room-connected',data: jsonString });
      sendDataToDart("room-connected", data);
      room.addEventListener("room-allowed", function (event) {
        sendDataToDart("room-allowed", event);

        // User is allowed into the room after being awaited
      });

      room.addEventListener("user-awaited", function (event, user) {
        sendDataToDart("user-awaited", event);


      });
      room.addEventListener("user-connected", function (event) {
        sendDataToDart("user-connected", event);


      });
      room.addEventListener("active-talkers-updated", function (event) {

        updateActiveList(event)
        sendDataToDart("active-talkers-updated", event.message);

        // List of talkers in the Room
        // Received after room-connected
      });
      room.addEventListener("room-disconnected", function (event) {

        sendDataToDart("room-disconnected", event.message);

        if (activeDivMap.has(0)) {
          removeNativeView(0)
        }
        window.location.reload();
        // You are disconnected
      });

      room.addEventListener("user-disconnected", function (event) {
        sendDataToDart("user-disconnected", event);
        console.log(nativeViewMap);

      });
      // Notification to others when a user muted audio
      room.addEventListener("user-audio-muted", function (event) {
        let data = { result: 0, msg: "User muted audio", clientId: event.clientId }
        sendDataToDart("user-audio-muted", data);

      });

      // Notification to others when a user muted audio
      room.addEventListener("user-audio-unmuted", function (event) {
        let data = { result: 0, msg: "User unmuted audio", clientId: event.clientId }
        sendDataToDart("user-audio-unmuted", data);
      });
      // Notification to others when a user muted video
      room.addEventListener("user-video-muted", function (event) {
        let data = { result: 0, msg: "User muted video", clientId: event.clientId }
        sendDataToDart("user-video-muted", data);

      });

      // Notification to others when a user muted video
      room.addEventListener("user-video-unmuted", function (event) {
        let data = { result: 0, msg: "User unmuted video", clientId: event.clientId }
        sendDataToDart("user-video-unmuted", event);
      });
      room.addEventListener('network-disconnected', function (event) {
        // Handle UI or prompt user.
      });
      room.addEventListener('network-reconnect-timeout', function (event) {
        // Re-Connect Attempt timed-out
      });

      room.addEventListener('network-reconnect-failed', function (event) {
        // Re-Connect Attempt failed
      });
      room.addEventListener("room-bandwidth-alert", function (evt) {
        /* evt carries JSON data, sample given below */
      });
      room.addEventListener("stream-added", function (event) {
        sendDataToDart("stream-added", event)
        if (localStream.getID() === event.stream.getID()) {
          // Your stream published
        } else {
          // Someone else has published
        }
      });

      room.addEventListener("stream-failed", function (event) {
        // Failed to publish
      });
      room.addEventListener("stream-subscribed", function (event) {
        // Stream subscribed
        //  sendDataToDart("stream-subscribed",event)
      });
      room.addEventListener("stream-attributes-updated", function (evt) {
        // evt.attributes - updated attributes of stream
      });
      room.addEventListener("message-received", function (event) {
        var InMsg = event.message;
        if (InMsg.broadcast === true) {
          // Handle Public Message
        }
        else {
          // Handle Message from InMsg.sender
        }
      });
      room.addEventListener("user-data-received", function (event) {
        var InMsg = event.message.msg;
        if (InMsg.broadcast === true) {
          // Handle Public Message
        }
        else {
          // Handle Message from InMsg.sender
        }
      });
      room.addEventListener("room-record-on", function (event) {
        sendDataToDart("room-record-on", event.message)
        // Recording started, Update UI
        // event.message.moderatorId = Moderator who stated recording.
      });

      // Notification recording stopped to all
      room.addEventListener("room-record-off", function (event) {
        sendDataToDart("room-record-off", event.message)
        // Recording stopped, Update UI
        // event.message.moderatorId = Moderator who stopped recording.
      });
      room.addEventListener("room-live-recording-on", function (event) {
        // Live recording is on
      });

      room.addEventListener("room-live-recording-failed", function (event) {
        // Failed to live record
      });
      room.addEventListener("room-live-recording-off", function (event) {
        // Live recording stopped
      });
      // Partipants are notifed on room being hard-muted
      room.addEventListener("hard-mute-room", function (res) {
        // res.moderator = Moderator who hard-muted Room.
        sendDataToDart("hard-mute-room", res)
      });

      // Partipants are notifed on room being hard-unmuted
      room.addEventListener("hard-unmute-room", function (res) {
        // res.moderator = Moderator who hard-unmuted Room.
        sendDataToDart("hard-unmute-room", res)
      });
      room.addEventListener("hardmute-user-audio", function (event) {
        sendDataToDart("hardmute-user-audio", event)
        // Your audio is hard muted
        // event.moderator = Moderator who hard-muted user's Audio.
      });

      room.addEventListener("hardmute-user-video", function (event) {
        // Your video is hard muted
        sendDataToDart("hardmute-user-video", event)

      });

      room.addEventListener("user-audio-muted", function (event) {
        // User's audio muted
        // Info about user event.stream.attributes
        sendDataToDart("user-audio-muted", event)
      });

      room.addEventListener("user-video-muted", function (event) {
        // User's video muted
        // Info about user event.stream.attributes
        sendDataToDart("user-video-muted", event)
      });
      //
      room.addEventListener("hardunmute-user-audio", function (event) {
        // User's video muted
        // Info about user event.stream.attributes
        sendDataToDart("hardunmute-user-audio", event)
      });
      room.addEventListener("hardunmute-user-video", function (event) {
        // User's video muted
        // Info about user event.stream.attributes
        sendDataToDart("hardunmute-user-video", event)
      });
      room.addEventListener("user-audio-unmuted", function (event) {
        // User's video muted
        // Info about user event.stream.attributes
        sendDataToDart("user-audio-unmuted", event)
      });
      room.addEventListener("user-video-unmuted", function (event) {
        // User's video muted
        // Info about user event.stream.attributes
        sendDataToDart("user-video-unmuted", event)
      });

      room.addEventListener('room-locked', function (event) {
        sendDataToDart("room-locked", event.message);
      });



      // Participants are notified that room has been unlocked
      room.addEventListener('room-unlocked', function (event) {
        sendDataToDart("room-unlocked", event.message);
      });
      room.addEventListener('conference-remaining-duration', function (event) {

        sendDataToDart("conference-remaining-duration", event.message);
        // Show UI to all usersr or to participant to
        // trigger EXTEND by caling method.
      });
      room.addEventListener('user-role-changed', function (event) {
        sendDataToDart("user-role-changed", event);
      });
      room.addEventListener('updated-pinned-users', function (event) {
        // event json { "moderator_id": String, "clientIds": [] }
        sendDataToDart("updated-pinned-users", event);
      });
      room.addEventListener('spotlight-users', function (event) {
        // event json { "moderator_id": String, "users": [] }
        sendDataToDart("spotlight-users", event);
      });
      // Notification to all
      room.addEventListener("room-mode-switched", function (event) {
        // evt is JSON, e.g.
        sendDataToDart("room-mode-switched", event);

      });
      // To receive message notification
      room.addEventListener("message-received", function (event) {
        sendDataToDart("message-received", event.message);
      });

      // To receive  custom data / signal notification
      room.addEventListener("user-data-received", function (event) {

        sendDataToDart("user-data-received", event.message);
      });

      // Notification to all when share starts
      room.addEventListener("share-started", function (event) {
        //                 	// Get Stream# 101 which carries Screen Share
        //                      	var shared_stream = room.remoteStreams.get(101);
        //                 	// Play in Player
        //                      	shared_stream.play("div_id", playerOptions);
        sendDataToDart("share-started", event.message);
      });
      room.addEventListener("share-stopped", function (event) {
        sendDataToDart("share-stopped", event.message);
      });
      room.addEventListener('streaming-started', function (event) {
        // All are notified that streaming has started
        // event.message.startedBy : who started the streaming
        sendDataToDart("streaming-started", event.message);

      });

      room.addEventListener('streaming-stopped', function (event) {
        // All are notified that streaming has stopped
        // event.message.stoppedBy : who stopped the streaming
        sendDataToDart("streaming-stopped", event.message);
      });

      room.addEventListener('streaming-failed', function (event) {
        // Notification that streaming failed
        sendDataToDart("streaming-failed", event.message);
      });

      room.addEventListener('streaming-updated', function (event) {
        sendDataToDart("streaming-updated", event.message);
      });
      room.addEventListener("room-live-recording-on", function (event) {
        // Live recording is on
        sendDataToDart("room-live-recording-on", event.message);
      });

      room.addEventListener("room-live-recording-failed", function (event) {
        // Failed to live record
        sendDataToDart("room-live-recording-failed", event.message);
      });
      room.addEventListener("room-live-recording-updated", function (event) {
        // Live recording stopped
        sendDataToDart("room-live-recording-updated", event.message);
      });
      room.addEventListener("room-live-recording-off", function (event) {
        // Live recording stopped
        sendDataToDart("room-live-recording-off", event.message);
      });
      // Notification self-transcription is on
      room.addEventListener("self-transcription-on", function (event) {
        sendDataToDart("self-transcription-on", event.message);
      });

      // Notification room-transcription is on
      room.addEventListener("room-transcription-on", function (event) {
        sendDataToDart("room-transcription-on", event.message);
      });

      // Notification transcripion data events
      room.addEventListener("transcription-events", function (event) {
        // print recognized speech
        sendDataToDart("transcription-events", event.message);
      }); // Notification self-transcription is turned off
      room.addEventListener("self-transcription-off", function (event) {
        sendDataToDart("self-transcription-off", event.message);
      });

      // Notification room-transcription is turned off
      room.addEventListener("room-transcription-off", function (event) {
        sendDataToDart("room-transcription-off", event.message);

      });
      room.addEventListener("hls_started", function (event) {
        sendDataToDart("hls_started", event.message);

      });
      room.addEventListener("hls_stopped", function (event) {
        sendDataToDart("hls_stopped", event.message);

      });
      room.addEventListener("hls_failed", function (event) {
        sendDataToDart("hls_failed", event.message);

      });
      room.addEventListener("hls_waiting", function (event) {
        sendDataToDart("hls_waiting", event.message);
      });
      room.addEventListener("talker-notification", function (event) {
        // evt is JSON with Talkers. Refer a sample given below
        sendDataToDart("talker-notification", event.message);

      });
      room.addEventListener("dial-state-events", function (event) {
        sendDataToDart("dial-state-events", event.message);

      });
      room.addEventListener("floor-requested", function (event) {
        /*  evt.users.clientId, evt.users.name */
        sendDataToDart("floor-requested", event.users);
      });
      // Moderator receives Floor Cancellattion Notification
      room.addEventListener("floor-cancelled", function (event) {
        // evt.msg.clientId = The participant who cancelled
        sendDataToDart("floor-cancelled", event.users);
      });
      // Affected Participant and Moderator(s) are notified about denied request
      room.addEventListener("floor-denied", function (event) {
        // evt.msg.moderatorId = The modeator who denied
        // evt.msg.clientId = The Participan who is denied
        sendDataToDart("floor-denied", event.users);
      });
      // Moderators and the Participant is notified about granted Floor Access
      room.addEventListener("floor-granted", function (event) {
        // room.publish(localStream); // Publish stream
        // evt.msg.moderatorId = Moderator who granted Floor Access
        sendDataToDart("floor-granted", event.users);
      });
      // Moderators receive notification
      room.addEventListener("floor-finished", function (event) {
        // evt.msg.clientId = The participant who finished floor access
        sendDataToDart("floor-finished", event.users);
      });
      // Notification when floor access is released
      room.addEventListener("release-floor", function (event) {
        // evt.msg.moderatorId = The moderator who released floor access
        // evt.msg.clientId = The Participant whose floor access is released
        sendDataToDart("release-floor", event.users);
      });
      room.addEventListener("floor-invited", function (event) {
        // evt is JSON, e.g.
        sendDataToDart("floor-invited", event.users);

      });
      // Notification to Moderators and invited  Participant
      room.addEventListener("floor-invite-cancelled", function (event) {
        // evt is JSON, e.g.
        sendDataToDart("floor-invite-cancelled", event.users);

      });
      // Notification to Moderators
      room.addEventListener("floor-accepted", function (event) {
        // evt is JSON, e.g.
        sendDataToDart("floor-accepted", event.users);

      });
      // Notification to Moderators
      room.addEventListener("floor-rejected", function (event) {
        // evt is JSON, e.g.
        sendDataToDart("floor-rejected", event.users);

      });
      room.addEventListener("join-breakout-room", function (event) {
        // event carries the invitation details, e.g.
        sendDataToDart("join-breakout-room", event.message);

      });
      // Users get notification to join directly when invited with  "force_join: true".
      room.addEventListener("breakout-room-joining", function (event) {
        // event carries the invitation details, e.g.
        sendDataToDart("breakout-room-joining", event.message);

      });

      // Users get notification when connected with Break-Out Room with invited with "force_join: true".
      room.addEventListener("breakout-room-connected", function (event) {
        // event carries the room meta
        sendDataToDart("breakout-room-connected", event.message);

      });

      // User fails to connect  to Break-Out Room
      room.addEventListener("breakout-room-error", function (result) {
        // result contains reasons of failed connection, e.g.
        sendDataToDart("breakout-room-error", event.message);

      });

      // Others are notified about the new joinee in Break-Out Room
      room.addEventListener("user-joined-breakout-room", function (result) {
        // result contains new joinee user's information
        sendDataToDart("user-joined-breakout-room", event.message);

      });
      room.addEventListener("breakout-invite-rejected", function (result) {
        sendDataToDart("breakout-invite-rejected", event.message);
      });
      // User is notified that he is disconnected from Break-Out Room
      room.addEventListener("breakout-room-disconnected", function (event) {
        sendDataToDart("breakout-room-disconnected", event.message);
      });

      // Others are notified about the user disconnected from Break-Out Room
      room.addEventListener("user-disconnected-breakout-room", function (event) {
        sendDataToDart("user-disconnected-breakout-room", event.message);
      });
      room.addEventListener("breakout-user-disconnected", function (event) {
        /* event is JSON with information of disconnected participant	 	*/
        sendDataToDart("breakout-user-disconnected", event.message);
      });
      room.addEventListener("breakout-room-destroyed", function (event) {
        sendDataToDart("breakout-room-destroyed", event.message);
      });
      if (room.waitRoom && room.me.role != "moderator") {
        // Wait for Moderator
      } else {
        remoteStreams = success.room.streams;
      }
    }
  },
    data.roomInfo
  )

}

function switchMediaDevice(data) {
  localStream.switchMicrophone(localStream, data.speakerId, function (Stream) {
    if (stream && stream.getID) {
      localStream = stream; // LocalStream updated
    }
    else {
      // Failed to switch
    }
  });
  room.switchSpeaker(data.speakerId, function (res) {
    if (res.result == 0) {
      // Switching successful
    }
    else {
      // Failed to switch
    }
  });

}
function disConnectRoom() {
  room.disconnect();

}
function destroy() {
  room.destroy()
}
function muteSelfAudio(data) {
  if (data.isMute) {
    localStream.muteAudio(function (res) {
      let data = { result: 0, msg: "Audio Off" }
      sendDataToDart("onAudioEvent", data);
    });
  } else {
    localStream.unmuteAudio(function (res) {
      let data = { result: 0, msg: "Audio On" }
      sendDataToDart("onAudioEvent", data);

    });
  }
}

function muteSelfVideo(data) {
  if (data.isMute) {
    localStream.muteVideo(function (res) {
      // Video muted. Handle UI here
      let data = { result: 0, msg: "Video Off" }
      sendDataToDart("onVideoEvent", data);
    });
  } else {
    localStream.unmuteVideo(function (res) {
      let data = { result: 0, msg: "Video On" }
      sendDataToDart("onVideoEvent", data);

      // Video unmuted. Handle UI here
    });
  }




}

function switchCamera(data) {
  //   localStream.switchCamera(localStream, camDeviceId, function(Stream) {
  //            if(stream && stream.getID) {
  //             localStream = stream; // LocalStream updated
  //            }
  //            else {
  //                // Failed to switch
  //            }
  //    });
}

function lockRoom(data) {
  room.lock();
}
function unlockRoom(data) {
  room.unlock();
}
function extendConferenceDuration(data) {
  room.extendConferenceDuration(function (message) {
    sendDataToDart("onConferencessExtended", message)
  });
}

function approveAwaitedUser(data) {
  room.approveAwaitedUser(data.clientId, function (success, error) {
    // Check Success / Error resul
    sendDataToDart("onAckForApproveAwaitedUser", success)
  });
}

function denyAwaitedUser(data) {
  room.denyAwaitedUser(data.clientId, function (success, error) {
    // Check Success / Error result
    sendDataToDart("onAckForDenyAwaitedUser", success)
  });
}

function switchUserRole(data) {
  room.switchUserRole(data.clientId, function (success, error) {
    // Check Success / Error result
    sendDataToDart("onSwitchedUserRole", success)
  });
}
//send message
function sendMessage(data) {
  room.sendMessage(data.message, data.isBroadCast, data.recipientIDs, function (data) {


    // Message sent
  });
}

//send message
function sendUserData(data) {
  room.sendUserData(data.message, data.isBroadCast, data.recipientIDs, function (data) {
    sendDataToDart("onAcknowledgedSendData", data)
  });
}

function sendFiles(data) {

  let shareOptions = {
    "isMobile": false,
    "broadcast": data.isBroadCast,
    "clientList": data.recipientIDs
  };
  room.sendFiles(shareOptions, function (resp) {

  });

}

function startScreenShare(data) {
  var ShareOption = {
    "audio": true,
    "layout": "presenter" /* You define this key. You may like to switch to Presenter Mode of UI at receiving end */
  };

  // Start Screen Share
  // streamShare = room.startScreenShare(ShareOption, function(result){

  sendDataToDart("onStartScreenShareACK", result)
  //});


}

function stopScreenShare(data) {

  //    room.stopScreenShare( streamShare, function(result) {
  //       sendDataToDart("onStoppedScreenShareACK",result)
  //
  //     });
}

//start streaming
function startStreaming(data) {
  // Start Streaming
  room.startStreaming(data.streamingDetails, function (resp) {
    sendDataToDart("onAckStartStreaming", resp)

  });

}
function stopStreaming(data) {
  room.stopStreaming(function (resp) {
    sendDataToDart("onAckStopStreaming", resp)
  })
}
function startLiveRecording(data) {

  room.startLiveRecording(data.streamingDetails, function (resp) {
    sendDataToDart("onACKStartLiveRecording", resp)
  });
}
function stopLiveRecording(data) {
  var myRecordConfig = {};
  room.stopLiveRecording(myRecordConfig, function (resp) {
    sendDataToDart("onACKStopLiveRecording", resp)
  });

}
function setTalkerCount(data) {
  room.setTalkerCount(data.count, function (resp) {
    // Set Talker info in response JSON:
    sendDataToDart("onSetTalkerCount", resp)
    // { "result": 0, "maxTalkers": 5 }
  });
}
function getTalkerCount() {
  room.getTalkerCount(function (response) {
    // Talker info in response JSON:
    sendDataToDart("onGetTalkerCount", resp)
  });
}
function getMaxTalkers() {
  room.getMaxTalkers(function (resp) {
    // Maximum Talker info in response JSON:
    sendDataToDart("onMaxTalkerCount", resp)
  });
}

function startRecord(data) {
  room.startRecord(function (result, error) {
    sendDataToDart("onStartRecordingEvent", result)
  });
}
function stopRecord(data) {
  room.stopRecord(function (result, error) {
    sendDataToDart("onStopRecordingEvent", result)
  });
}

function hardMute(data) {
  room.hardMute(function (result, error) {
    sendDataToDart("onHardMuted", result)
  });
}
function hardUnMute(data) {
  room.hardUnmute(function (result, error) {
    sendDataToDart("onHardUnMuted", result)
  });
}
function hardMuteAudio(data) {
  room.hardMuteUserAudio(data.clientId, function (result, error) {
    // sendDataToDart("onAckHardMuteUserAudio",result)
  });
}
function hardUnMuteAudio(data) {
  room.hardUnmuteUserAudio(data.clientId, function (result, error) {
    // sendDataToDart("onAckHardunMuteUserAudio",result)
  });
}

function hardMuteVideo(data) {
  room.hardMuteUserVideo(data.clientId, function (result, error) {
    //  sendDataToDart("onAckHardMuteUserVideo",result)
  });
}
function hardUnMuteVideo(data) {
  room.hardUnmuteUserVideo(data.clientId, function (result, error) {
    // sendDataToDart("onAckHardUnMuteUserVideo",result)
  });
}

function pinUsers(data) {
  room.pinUsers(data.userList, function (resp) {
    // resp json { "result": Number, "clients": [] }
    sendDataToDart("onAckPinUsers", resp)
  });
}
// To unpin users
function unpinUsers(data) {
  room.unpinUsers(data.userList, function (resp) {
    // resp json { "result": Number, "clientIds": [] }
    sendDataToDart("onAckUnpinUsers", resp)
  });
}

function addSpotlightUsers(data) {
  room.addSpotlightUsers(data.userList, function (resp) {
    // resp json { "result": Number, "clients": [] }
    sendDataToDart("onAckAddSpotlightUsers", resp)
  });
}
// To unpin users
function removeSpotlightUsers(data) {
  room.removeSpotlightUsers(data.userList, function (resp) {
    // resp json { "result": Number, "clientIds": [] }
    sendDataToDart("onAckRemoveSpotlightUsers", resp)
  });
}
//switch room mode
function switchRoomMode(data) {
  room.switchRoomMode(data.roomMode, function (resp) {
    // resp json { "result": Number, "clientIds": [] }
    sendDataToDart("onAckSwitchedRoom", resp)
  });
}

function startLiveTranscriptionForRoom(data) {
  room.startLiveTranscriptionForRoom(data.language, function (result, error) {
    sendDataToDart("onACKStartLiveTranscription", result)
  });
}
function stopLiveTranscription(data) {
  room.stopLiveTranscription(function (result, error) {
    sendDataToDart("onACKStopLiveTranscription", result)
  });
}

function subscribeForTalkerNotification(data) {
  room.subscribeForTalkerNotification(data.isTalkerNotification, function (resp) {
    if (data.isTalkerNotification) {
      sendDataToDart("onAckSubscribeTalkerNotification", result)
    } else {
      sendDataToDart("onAckUnsubscribeTalkerNotification", result)
    }


  });
}

function enableStats(data) {

}
function setAudioOnlyMode(data) {
  room.setAudioOnlyMode(data.audioOnly);
}

function makeOutboundCall(data) {

  var dialout_option = {
    //              "name": "John",
    //             "early_media": false,
    //               "silent_join": true
  };
  room.makeOutboundCall(data.number, data.callerId, dialout_option, function (resp) {
    sendDataToDart("onOutBoundCallInitiated", result);
  });
}
function cancelOutboundCall(data) {
  room.cancelOutboundCall(data.number, function (resp) {
    sendDataToDart("onOutBoundCallCancel", resp)
  });

}
function sendDTMF(data) {
  var dtmf_option = {
    "number": data.number,
    "digits": data.digits
  };

  room.sendDTMF(dtmf_option, function (resp) {
    sendDataToDart("onOutBoundCallSendDtmf", resp)

  });
}

function captureScreenShot(data) {
  localStream.getVideoFrameImage()

}

function requestFloor(data) {
  room.requestFloor(function (arg) {
    sendDataToDart("onFloorRequested", arg)
  });
}
function grantFloor(data) {
  room.grantFloor(data.clientId, function (arg) {
    sendDataToDart("onProcessFloorRequested", arg)
  });

}

function cancelFloor(data) {
  room.cancelFloor(function (arg) {
    sendDataToDart("onFloorCancelled", arg)
  });
}
function finishFloor(data) {
  room.finishFloor(function (arg) {
    sendDataToDart("onFloorFinished", arg)
  });
}
function denyFloor(data) {
  room.denyFloor(data.clientId, function (arg) {
    sendDataToDart("onProcessFloorRequested", arg)
  });

}

function releaseFloor(data) {
  room.relaseFloor(data.clientId, function (arg) {
    sendDataToDart("onProcessFloorRequested", arg)
  });
}
function inviteToFloor(data) {
  room.inviteToFloor(data.clientId, function (resp) {
    sendDataToDart("onACKInviteToFloorRequested", arg)
  });
}
function cancelFloorInvite(data) {
  // Cancel Invitation to Floor for a Participant
  room.cancelFloorInvite(data.clientId, function (resp) {
    sendDataToDart("onProcessFloorRequested", arg)
  });
}
function rejectInviteFloor(data) {
  // Invited Participant to accept Invitation to join Floor
  room.acceptInviteFloorRequest(function (resp) {
    sendDataToDart("onProcessFloorRequested", arg)
  });
}
function acceptInviteFloorRequest(data) {
  // Invited Participant to reject Invitation to join Floor
  room.rejectInviteFloor(function (resp) {
    sendDataToDart("onProcessFloorRequested", arg)
  });
}

//breakout room
function createBreakOutRoom(data) {
  room.createBreakoutRoom(data.createBreakoutInfo, function (resp) {
    // data is JSON with created Break-Out Room Information, e.g.
    sendDataToDart("onAckCreateBreakOutRoom", resp)

  });
}
function createAndInviteBreakoutRoom(data) {

  room.createAndInviteBreakoutRoom(data.createandInviteBreakOutInfo, function (resp) {
    // data is JSON with created Break-Out Room Information, e.g.
    sendDataToDart("onAckCreateAndInviteBreakOutRoom", resp)
  });
}
function joinBreakOutRoom(data) {
  room.joinBreakOutRoom(data.dataInfo, data.streamInfo, function (resp) {
    // Status
  });
}
function inviteToBreakOutRoom(data) {
  room.inviteToBreakoutRoom(data.inviteBreakOutInfo, function (resp) {
    // resp is the result of invitation process, e.g.
    sendDataToDart("onAckInviteBreakOutRoom", resp)

  });
}
function pause(data) {
  room.pauseRoom(function (resp) {
    sendDataToDart("onAckPause", resp)
  });
}
function resume(data) {
  room.resumeRoom(function (resp) {
    // resp carries status
    sendDataToDart("onAckResume", resp)
  });
}
function muteRoom(data) {
  room.muteRoom(data.muteRoomInfo, function (resp) {
    // resp carries status
    sendDataToDart("onAckMuteRoom", resp)
  });
}
function unmuteRoom(data) {
  room.unMuteRoom(data.unMuteRoomInfo, function (resp) {
    // resp carries status
    sendDataToDart("onAckUnmuteRoom", resp)
  });
}
function rejectBreakOutRoom(data) {
  room.rejectBreakOutRoomInvitation(roomId, function (resp) {
    // Status
    sendDataToDart("onAckRejectBreakOutRoom", resp)

  });
}

//for js
const nativeViewMap = new Map();
let activeDivMap = new Map();
let viewIdMap = new Map();
function createNativeView(data) {
  if (data==0) {
    activeDivMap.set(data, data);
  }

  if (!viewIdMap.has(data)) {
    viewIdMap.set(data, data);
  }

  if (!activeDivMap.has(data)) {
    if (data != 0) {
      remoteStreamDiv(data);
    }
  }

  // nativeViewMap.set(data.uid, data);
}

function createNativeViewDiv(data) {
  const nativeViewId = data;
 // const nativeView = document.createElement('div');
  const element = document.getElementById(`${nativeViewId}`);

 // nativeView.id = nativeViewId;

  //  element.appendChild(nativeView);
  activeDivMap.set(nativeViewId, element);

  var PlayerOpt = {
    player: {
      'height': "100px",
      'width': "100px",
      'minHeight': 'inherit',
      'minWidth': 'inherit'
    },
    toolbar: {
      displayMode: false,
      branding: {
        display: false
      }
    }
  };

  localStream.play(nativeViewId, PlayerOpt);
  setTimeout(function () {
      let playerView = document.querySelector(`#player_${nativeViewId} video`)
     if(playerView!=null){
      playerView.style = 'width:100% !important;height:100% !important;'
         console.log('payerView', playerView);
     }

    }, 1000);
  // return nativeViewId;
}
function removeNativeView(viewId) {

  if (activeDivMap.has(viewId)) {
    activeDivMap.get(viewId).remove();
    activeDivMap.delete(viewId);
    console.log(activeDivMap);
  }
}
// Expose methods to Flutter
window.nativeView = {
  createNativeView,
  removeNativeView,
};


function remoteStreamDiv(remoteStreamObj) {
  const nativeViewId = remoteStreamObj;
  const element = document.getElementById('' + nativeViewId);
  activeDivMap.set(nativeViewId, element);
  var PlayerOpt = {
    player: {
      'height': "100px",
      'width': "100px",
      'minHeight': 'inherit',
      'minWidth': 'inherit'
    },
    toolbar: {
      displayMode: false,
      branding: {
        display: false
      }
    }
  };
  room.remoteStreams.get(nativeViewId).play(nativeViewId, PlayerOpt);
  setTimeout(function () {
    let playerView = document.querySelector(`#player_${nativeViewId} video`)
   if(playerView!=null){
    playerView.style = 'width:100% !important;height:100% !important;'
   }
   console.log('payerView', playerView);

  }, 1000);
}


function sendDataToDart(methodName, data) {
  var jsonString = JSON.stringify(data);
  dartCallback({ methodName: methodName, data: jsonString });
}

function parseData(roomData) {
  let parseItems = {}
  Object.keys(roomData).forEach((item) => {
    if (typeof (roomData[item]) != 'function' && item != 'socket') {
      parseItems[item] = roomData[item];
    }
  });
  return parseItems;
}

let oldAT = new Map()
//maintainActive talker list
function updateActiveList(event) {
  const ATList = event.message.activeList
  const newAT = new Map()
  if (!oldAT.size) {
    ATList.forEach(item => {
      oldAT.set(item.streamId, item)
      newAT.set(item.streamId, item)
    })
  } else {
    ATList.forEach(async item => {
      newAT.set(item.streamId, item)
    })
    for (let [key, value] of oldAT) {
      let a = newAT.get(key)
      if (!a) {
        let removableStreamID = value
        removeNativeView(removableStreamID.streamId)
        let data={id:removableStreamID.streamId}
        sendDataToDart("removeView",data)
      }
    }
    oldAT = newAT

  }
  // updateView(oldAT)


}

