import 'dart:convert';
import 'dart:collection';
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'dart:async';
import 'package:enx_flutter_plugin/enx_player_widget.dart';
import 'package:enx_flutter_plugin/enx_flutter_plugin.dart';
import 'package:flutter/services.dart';
import 'package:enx_flutter_plugin/base.dart';
import 'package:flutter/foundation.dart' show kIsWeb;
import 'package:fluttertoast/fluttertoast.dart';
class CallUi extends StatefulWidget {
  CallUi({ required this.token});
  final String token;
  @override
  CallUiState createState() => CallUiState();
}

class CallUiState extends State<CallUi> {
  bool isAudioMuted = false;
  bool isVideoMuted = false;
  bool isAudioEnergy=false;
   late String streamId;
   late String streamId3;
   late int streamId2;
   late String base64String;
  bool isScreenShare=false;
  bool isConnected=false;
  @override
  void initState() {
    super.initState();
    print('Enablex Demo');
    initEnxRtc();
    _addEnxrtcEventHandlers();
  }

  Future<void> initEnxRtc() async {
    Map<String,dynamic> map4 ={
      'audiomute': true,
      'videomute':true,
      'bandwidth': true,
      'screenshot' : true,
      'avatar': true,
      'pinned' : true,
      'iconHeight' : 25,
      'iconWidth' : 25,
      'avatarHeight' : 200,
      'avatarWidth' : 200,
    };
    Map<String, dynamic> map2 = {
      'minWidth': 320,
      'minHeight': 180,
      'maxWidth': 1280,
      'maxHeight': 720
    };
    Map<String, dynamic> map1 = {
      'audio': true,
      'video': true,
      'data': true,

      'audioMuted': false,
      'videoMuted': false,
      'name': 'flutter',
    };
    Map<String, dynamic> map3 = {
      'allow_reconnect': true,
      'number_of_attempts': 3,
      'timeout_interval': 10000,

    };


    print('tokenRelease:${widget.token}');

      await EnxRtc.joinRoom(widget.token, map1, map3, []);

  }

  void _addEnxrtcEventHandlers() {
    EnxRtc.onRoomConnected = (Map<dynamic, dynamic> map) {
      setState(() {
        isConnected=true;
        print('onRoomConnectedFlutter' + jsonEncode(map));
      });
      EnxRtc.publish();


    };

    EnxRtc.onPublishedStream = (Map<dynamic, dynamic> map) {
      setState(() {
        print('onPublishedStream' + jsonEncode(map));
        streamId = map['streamId'];
        EnxRtc.setupVideo(0, 0, true, 300, 200);
       // EnxRtc.setMirror(false);


      });
    };
    EnxRtc.OnCapturedView=(String bitmap){
      setState(() {
        base64String=bitmap;
        print('OnCapture dView' + bitmap);
        Clipboard.setData(ClipboardData(text: bitmap));



      });
    };
    EnxRtc.onStreamAdded = (Map<dynamic, dynamic> map) {
      print('onStreamAdded' + jsonEncode(map));
      print('onStreamAdded Id' + map['streamId']);

      late String streamId1;
      setState(() {
        streamId1 = map['streamId'];
      });

      EnxRtc.subscribe(streamId1);
    };

    EnxRtc.onRoomError = (Map<dynamic, dynamic> map) {
      setState(() {
        print('onRoomError' + jsonEncode(map));
      });
    };
    EnxRtc.onNotifyDeviceUpdate = (String deviceName) {
      print('onNotifyDeviceUpdate' + deviceName);
    };

    EnxRtc.onActiveTalkerList = (Map<dynamic, dynamic> map) {
      print('onActiveTalkerList ' + map.toString());
    // updateActiveList((map['activeList'] as List));
      final items = (map['activeList'] as List)
          .map((i) => new ActiveListModel.fromJson(i));
     // _streamID = items.first.streamId;
      if(_remoteUsers.isNotEmpty){
        for(int i=0;i<_remoteUsers.length;i++){
          setState(() {
            _remoteUsers.removeAt(i);
          });

        }
      }
      if (items.isNotEmpty) {
        for (final item in items) {
          if(!_remoteUsers.contains(item.streamId)){
            print('_remoteUsers $map');
            setState(() {
              _streamID = item.streamId;
              streamId2 = item.streamId  ;
              base64String=  item.clientId;
              _remoteUsers.add(item.streamId);
            });
          }
        }
        print('_remoteUsersascashjc');
        print('_remoteUsersascashjc count at index ${_remoteUsers.first}');

      }
    };

    EnxRtc.onEventError = (Map<dynamic, dynamic> map) {
      setState(() {
        print('onEventError' + jsonEncode(map));
      });
    };

    EnxRtc.onEventInfo = (Map<dynamic, dynamic> map) {
      setState(() {
        print('onEventInfo' + jsonEncode(map));
      });
    };
    EnxRtc.onUserConnected = (Map<dynamic, dynamic> map) {
      setState(() {
        print('onUserConnected' + jsonEncode(map));
      });
    };
    EnxRtc.onUserDisConnected = (Map<dynamic, dynamic> map) {
      setState(() {
        print('onUserDisConnected' + jsonEncode(map));

      });
    };
    EnxRtc.onRoomDisConnected = (Map<dynamic, dynamic> map) {
      setState(() {
        print('onRoomDisConnected' + jsonEncode(map));
          Navigator.pop(context);
       // Navigator.pop(context, '/Conference');
      });
    };
    EnxRtc.onAudioEvent = (Map<dynamic, dynamic> map) {
      print('onAudioEvent' + jsonEncode(map));
      setState(() {
        if (map['msg'].toString() == "Audio Off") {
          isAudioMuted = true;
        } else {
          isAudioMuted = false;
        }
      });
    };
    EnxRtc.onVideoEvent = (Map<dynamic, dynamic> map) {
      print('onVideoEvent' + jsonEncode(map));
      setState(() {
        if (map['msg'].toString() == "Video Off") {
          isVideoMuted = true;
        } else {
          isVideoMuted = false;
        }
      });
    };
    EnxRtc.onAckSubscribeTalkerNotification=(Map<dynamic, dynamic> map) {
      isAudioEnergy = true;
      print('onAckSubscribeTalkerNotification12' + jsonEncode(map));
      Fluttertoast.showToast(
          msg: "onAckSubscribeTalkerNotification12+${jsonEncode(map)}",
          toastLength: Toast.LENGTH_SHORT,
          gravity: ToastGravity.CENTER,

          backgroundColor: Colors.red,
          textColor: Colors.white,
          fontSize: 16.0
      );
    };
    EnxRtc.onAckUnsubscribeTalkerNotification=(Map<dynamic, dynamic> map) {
      print('onAckUnsubscribeTalkerNotification12' + jsonEncode(map));
      isAudioEnergy = false;
      Fluttertoast.showToast(
          msg: "onAckUnsubscribeTalkerNotification12+${jsonEncode(map)}",
          toastLength: Toast.LENGTH_SHORT,
          gravity: ToastGravity.CENTER,

          backgroundColor: Colors.red,
          textColor: Colors.white,
          fontSize: 16.0
      );
    };
    EnxRtc.onTalkerNtification=(Map<dynamic, dynamic> map) {
      print('onTalkerNtification' + jsonEncode(map));
      Fluttertoast.showToast(
          msg: "onTalkerNtification+${jsonEncode(map)}",
          toastLength: Toast.LENGTH_SHORT,
          gravity: ToastGravity.CENTER,

          backgroundColor: Colors.red,
          textColor: Colors.white,
          fontSize: 16.0
      );
    };
    EnxRtc.onClientDiagnosisFailed=(Map<dynamic, dynamic> map) {
      print('onClientDiagnosisFailed' + jsonEncode(map));
    };
    EnxRtc.onClientDiagnosisFinished=(Map<dynamic, dynamic> map) {
      print('onClientDiagnosisFinished' + jsonEncode(map));
    };
    EnxRtc.onClientDiagnosisStatus=(Map<dynamic, dynamic> map) {
      print('onClientDiagnosisStatus' + jsonEncode(map));
    };
    EnxRtc.onClientDiagnosisStopped=(Map<dynamic, dynamic> map) {
      print('onClientDiagnosisStopped' + jsonEncode(map));
    };
    //
    EnxRtc.onAckCreateBreakOutRoom=(Map<dynamic, dynamic> map) {
      print('onAckCreateBreakOutRoom' + jsonEncode(map));
      Fluttertoast.showToast(
          msg: "onAckCreateBreakOutRoom+${jsonEncode(map)}",
          toastLength: Toast.LENGTH_SHORT,
          gravity: ToastGravity.CENTER,

          backgroundColor: Colors.red,
          textColor: Colors.white,
          fontSize: 16.0
      );
    };
    EnxRtc.onAckCreateAndInviteBreakOutRoom=(Map<dynamic, dynamic> map) {
      print('onAckCreateAndInviteBreakOutRoom' + jsonEncode(map));
    };
    EnxRtc.onAckInviteBreakOutRoom=(Map<dynamic, dynamic> map) {
      print('onAckInviteBreakOutRoom' + jsonEncode(map));
    };

    EnxRtc.onFailedJoinBreakOutRoom=(Map<dynamic, dynamic> map) {
      print('onFailedJoinBreakOutRoom' + jsonEncode(map));
    };
    EnxRtc.onConnectedBreakoutRoom=(Map<dynamic, dynamic> map) {
      print('onConnectedBreakoutRoom' + jsonEncode(map));
    };
    EnxRtc.onDisconnectedBreakoutRoom=(Map<dynamic, dynamic> map) {
      print('onDisconnectedBreakoutRoom' + jsonEncode(map));
    };
    EnxRtc.onUserJoinedBreakoutRoom=(Map<dynamic, dynamic> map) {
      print('onUserJoinedBreakoutRoom' + jsonEncode(map));
    };
    EnxRtc.onInvitationForBreakoutRoom=(Map<dynamic, dynamic> map) {
      print('onInvitationForBreakoutRoom' + jsonEncode(map));
    };
    EnxRtc.onDestroyedBreakoutRoom=(Map<dynamic, dynamic> map) {
      print('onDestroyedBreakoutRoom' + jsonEncode(map));
    };
    EnxRtc.onUserDisconnectedFromBreakoutRoom=(Map<dynamic, dynamic> map) {
      print('onUserDisconnectedFromBreakoutRoom' + jsonEncode(map));
    };

    EnxRtc.onUserAwaited=(Map<dynamic, dynamic> map) {
      print('onUserAwaited' + jsonEncode(map));
    };
    EnxRtc.onRoomAwaited=(Map<dynamic, dynamic> map) {
      print('onRoomAwaited' + jsonEncode(map));
    };
    EnxRtc.onAckForApproveAwaitedUser=(Map<dynamic, dynamic> map) {
      print('onAckForApproveAwaitedUser' + jsonEncode(map));
    };
    EnxRtc.onAckForApproveAwaitedUser=(Map<dynamic, dynamic> map) {
      print('onAckForApproveAwaitedUser' + jsonEncode(map));
    };
    EnxRtc.onAckForDenyAwaitedUser=(Map<dynamic, dynamic> map) {
      print('onAckForDenyAwaitedUser' + jsonEncode(map));
    };
    EnxRtc.onAckAddSpotlightUsers=(Map<dynamic, dynamic> map) {
      isAudioEnergy = true;
      print('onAckAddSpotlightUsers' + jsonEncode(map));
      Fluttertoast.showToast(
          msg: "onAckForDenyAwaitedUser+${jsonEncode(map)}",
          toastLength: Toast.LENGTH_SHORT,
          gravity: ToastGravity.CENTER,

          backgroundColor: Colors.red,
          textColor: Colors.white,
          fontSize: 16.0
      );
    };
    EnxRtc.onAckRemoveSpotlightUsers=(Map<dynamic, dynamic> map) {
      isAudioEnergy = false;
      print('onAckRemoveSpotlightUsers' + jsonEncode(map));
      Fluttertoast.showToast(
          msg: "onAckRemoveSpotlightUsers+${jsonEncode(map)}",
          toastLength: Toast.LENGTH_SHORT,
          gravity: ToastGravity.CENTER,

          backgroundColor: Colors.red,
          textColor: Colors.white,
          fontSize: 16.0
      );
    };
    EnxRtc.onUpdateSpotlightUsers=(Map<dynamic, dynamic> map) {
      print('onUpdateSpotlightUsers' + jsonEncode(map));
    };
    EnxRtc.onAckSwitchedRoom=(Map<dynamic, dynamic> map) {
      print('onAckSwitchedRoom' + jsonEncode(map));
      Fluttertoast.showToast(
          msg: "onAckSwitchedRoom+${jsonEncode(map)}",
          toastLength: Toast.LENGTH_SHORT,
          gravity: ToastGravity.CENTER,

          backgroundColor: Colors.red,
          textColor: Colors.white,
          fontSize: 16.0
      );
    };
    EnxRtc.onRoomModeSwitched=(Map<dynamic, dynamic> map) {
      print('onRoomModeSwitched' + jsonEncode(map));
      Fluttertoast.showToast(
          msg: "onRoomModeSwitched+${jsonEncode(map)}",
          toastLength: Toast.LENGTH_SHORT,
          gravity: ToastGravity.CENTER,

          backgroundColor: Colors.red,
          textColor: Colors.white,
          fontSize: 16.0
      );
    };
    //
    EnxRtc.onHardMutedAudio=(Map<dynamic, dynamic> map){
      isAudioMuted=true;
      Fluttertoast.showToast(
          msg: "onHardMutedVideo+${jsonEncode(map)}",
          toastLength: Toast.LENGTH_SHORT,
          gravity: ToastGravity.CENTER,

          backgroundColor: Colors.red,
          textColor: Colors.white,
          fontSize: 16.0
      );
    };
    EnxRtc.onHardUnMutedAudio=(Map<dynamic, dynamic> map){
      isAudioMuted=false;
      Fluttertoast.showToast(
          msg: "onHardUnMutedAudio+${jsonEncode(map)}",
          toastLength: Toast.LENGTH_SHORT,
          gravity: ToastGravity.CENTER,

          backgroundColor: Colors.red,
          textColor: Colors.white,
          fontSize: 16.0
      );
    };
    EnxRtc.onReceivedHardMuteAudio=(Map<dynamic, dynamic> map){
      isAudioMuted=false;
      Fluttertoast.showToast(
          msg: "onHardUnMutedAudio+${jsonEncode(map)}",
          toastLength: Toast.LENGTH_SHORT,
          gravity: ToastGravity.CENTER,

          backgroundColor: Colors.red,
          textColor: Colors.white,
          fontSize: 16.0
      );
    };
    EnxRtc.onReceivedHardUnMuteAudio=(Map<dynamic, dynamic> map){
      isAudioMuted=false;
      Fluttertoast.showToast(
          msg: "onHardUnMutedAudio+${jsonEncode(map)}",
          toastLength: Toast.LENGTH_SHORT,
          gravity: ToastGravity.CENTER,

          backgroundColor: Colors.red,
          textColor: Colors.white,
          fontSize: 16.0
      );
    };

    EnxRtc.onRoomBandwidthAlert=(Map<dynamic,dynamic> map){


    };
    EnxRtc.onAckForDenyAwaitedUser=(Map<dynamic,dynamic> map){

    };
    EnxRtc.onRoomAwaited=(Map<dynamic,dynamic> map){

    };
    EnxRtc.onUserAwaited=(Map<dynamic,dynamic> map){

    };
    EnxRtc.onMessageReceived=(Map<dynamic,dynamic> map){
      Fluttertoast.showToast(
          msg: "onMessageReceived+${jsonEncode(map)}",
          toastLength: Toast.LENGTH_SHORT,
          gravity: ToastGravity.CENTER,

          backgroundColor: Colors.red,
          textColor: Colors.white,
          fontSize: 16.0
      );
    };
    EnxRtc.onScreenSharedStarted=(Map<dynamic, dynamic> map){
      Fluttertoast.showToast(
          msg: "onScreenSharedStarted+${jsonEncode(map)}",
          toastLength: Toast.LENGTH_SHORT,
          gravity: ToastGravity.CENTER,
          backgroundColor: Colors.red,
          textColor: Colors.white,
          fontSize: 16.0
      );
      setState(() {
        isScreenShare=true;
        streamId3 = map['streamId'];
      });
    };
    EnxRtc.onScreenSharedStopped=(Map<dynamic, dynamic> map){
      setState(() {
        isScreenShare=false;
      });

      Fluttertoast.showToast(
          msg: "onScreenSharedStopped+${jsonEncode(map)}",
          toastLength: Toast.LENGTH_SHORT,
          gravity: ToastGravity.CENTER,
          backgroundColor: Colors.red,
          textColor: Colors.white,
          fontSize: 16.0);
    };
    EnxRtc.onACKStartLiveRecording=(Map<dynamic, dynamic> map){
      print('onACKStartLiveRecording' + jsonEncode(map));
      Fluttertoast.showToast(
          msg: "onACKStartLiveRecording+${jsonEncode(map)}",
          toastLength: Toast.LENGTH_SHORT,
          gravity: ToastGravity.CENTER,
          backgroundColor: Colors.red,
          textColor: Colors.white,
          fontSize: 16.0);
    };
    EnxRtc.onACKStopLiveRecording=(Map<dynamic, dynamic> map){
      print('onACKStopLiveRecording' + jsonEncode(map));
      Fluttertoast.showToast(
          msg: "onACKStopLiveRecording+${jsonEncode(map)}",
          toastLength: Toast.LENGTH_SHORT,
          gravity: ToastGravity.CENTER,
          backgroundColor: Colors.red,
          textColor: Colors.white,
          fontSize: 16.0);
    };
    EnxRtc.onRoomLiveRecordingUpdate=(Map<dynamic, dynamic> map){
      print('onRoomLiveRecordingUpdate' + jsonEncode(map));
      Fluttertoast.showToast(
          msg: "onRoomLiveRecordingUpdate+${jsonEncode(map)}",
          toastLength: Toast.LENGTH_SHORT,
          gravity: ToastGravity.CENTER,
          backgroundColor: Colors.red,
          textColor: Colors.white,
          fontSize: 16.0);
    };
    EnxRtc.onRoomLiveRecordingOn=(Map<dynamic, dynamic> map){
      print('onRoomLiveRecordingOn' + jsonEncode(map));
      Fluttertoast.showToast(
          msg: "onRoomLiveRecordingOn+${jsonEncode(map)}",
          toastLength: Toast.LENGTH_SHORT,
          gravity: ToastGravity.CENTER,
          backgroundColor: Colors.red,
          textColor: Colors.white,
          fontSize: 16.0);
    };
    EnxRtc.onOutBoundCallCancel=(Map<dynamic, dynamic> map){
      print('onOutBoundCallCancel' + jsonEncode(map));
      Fluttertoast.showToast(
          msg: "onOutBoundCallCancel+${jsonEncode(map)}",
          toastLength: Toast.LENGTH_SHORT,
          gravity: ToastGravity.CENTER,
          backgroundColor: Colors.red,
          textColor: Colors.white,
          fontSize: 16.0);
    };
    EnxRtc.onAnnotationStarted=(Map<dynamic, dynamic> map){
      Fluttertoast.showToast(
          msg: "onAnnotationStarted+${jsonEncode(map)}",
          toastLength: Toast.LENGTH_SHORT,
          gravity: ToastGravity.CENTER,
          backgroundColor: Colors.red,
          textColor: Colors.white,
          fontSize: 16.0
      );
      /* setState(() {
        isScreenShare=true;
        streamId3 = map['streamId'];
      });
*/    };
    EnxRtc.onAnnotationStopped=(Map<dynamic, dynamic> map){
      Fluttertoast.showToast(
          msg: "onAnnotationStopped+${jsonEncode(map)}",
          toastLength: Toast.LENGTH_SHORT,
          gravity: ToastGravity.CENTER,
          backgroundColor: Colors.red,
          textColor: Colors.white,
          fontSize: 16.0
      );
    };
    EnxRtc.onStartAnnotationAck=(Map<dynamic, dynamic> map){

      Fluttertoast.showToast(
          msg: "onStartAnnotationAck+${jsonEncode(map)}",
          toastLength: Toast.LENGTH_SHORT,
          gravity: ToastGravity.CENTER,
          backgroundColor: Colors.red,
          textColor: Colors.white,
          fontSize: 16.0
      );
      setState(() {
        isScreenShare=true;
        streamId3 = map['streamId'];
      });
    };
    EnxRtc.onStoppedAnnotationAck=(Map<dynamic, dynamic> map){
      Fluttertoast.showToast(
          msg: "onStoppedAnnotationAck+${jsonEncode(map)}",
          toastLength: Toast.LENGTH_SHORT,
          gravity: ToastGravity.CENTER,
          backgroundColor: Colors.red,
          textColor: Colors.white,
          fontSize: 16.0
      );
      setState(() {
        isScreenShare=true;
        streamId3 = map['streamId'];
      });
    };

    EnxRtc.onSharePermissionsModeChanged==(Map<dynamic, dynamic> map){
      Fluttertoast.showToast(
          msg: "onSharePermissionsModeChanged+${jsonEncode(map)}",
          toastLength: Toast.LENGTH_SHORT,
          gravity: ToastGravity.CENTER,
          backgroundColor: Colors.red,
          textColor: Colors.white,
          fontSize: 16.0
      );
    };
    EnxRtc.onACKGrantSharePermission==(Map<dynamic, dynamic> map){
      Fluttertoast.showToast(
          msg: "onACKGrantSharePermission+${jsonEncode(map)}",
          toastLength: Toast.LENGTH_SHORT,
          gravity: ToastGravity.CENTER,
          backgroundColor: Colors.red,
          textColor: Colors.white,
          fontSize: 16.0
      );
    };
    EnxRtc.onACKDenySharePermission==(Map<dynamic, dynamic> map){
      Fluttertoast.showToast(
          msg: "onACKDenySharePermission+${jsonEncode(map)}",
          toastLength: Toast.LENGTH_SHORT,
          gravity: ToastGravity.CENTER,
          backgroundColor: Colors.red,
          textColor: Colors.white,
          fontSize: 16.0
      );
    };
    EnxRtc.onACKReleaseSharePermission==(Map<dynamic, dynamic> map){
      Fluttertoast.showToast(
          msg: "onACKReleaseSharePermission+${jsonEncode(map)}",
          toastLength: Toast.LENGTH_SHORT,
          gravity: ToastGravity.CENTER,
          backgroundColor: Colors.red,
          textColor: Colors.white,
          fontSize: 16.0
      );
    };
    EnxRtc.onACKRequestSharePermission==(Map<dynamic, dynamic> map){
      Fluttertoast.showToast(
          msg: "onACKRequestSharePermission+${jsonEncode(map)}",
          toastLength: Toast.LENGTH_SHORT,
          gravity: ToastGravity.CENTER,
          backgroundColor: Colors.red,
          textColor: Colors.white,
          fontSize: 16.0
      );
    };
    EnxRtc.onACKSetSharePermissionMode==(Map<dynamic, dynamic> map){
      Fluttertoast.showToast(
          msg: "onACKSetSharePermissionMode+${jsonEncode(map)}",
          toastLength: Toast.LENGTH_SHORT,
          gravity: ToastGravity.CENTER,
          backgroundColor: Colors.red,
          textColor: Colors.white,
          fontSize: 16.0
      );
    };
    EnxRtc.onACKCancelSharePermission==(Map<dynamic, dynamic> map){
      Fluttertoast.showToast(
          msg: "onACKCancelSharePermission+${jsonEncode(map)}",
          toastLength: Toast.LENGTH_SHORT,
          gravity: ToastGravity.CENTER,
          backgroundColor: Colors.red,
          textColor: Colors.white,
          fontSize: 16.0
      );
    };
    EnxRtc.onSharePermissionRequested==(Map<dynamic, dynamic> map){
      Fluttertoast.showToast(
          msg: "onSharePermissionRequested+${jsonEncode(map)}",
          toastLength: Toast.LENGTH_SHORT,
          gravity: ToastGravity.CENTER,
          backgroundColor: Colors.red,
          textColor: Colors.white,
          fontSize: 16.0
      );
    };

    EnxRtc.onSharePermissionReleased==(Map<dynamic, dynamic> map){
      Fluttertoast.showToast(
          msg: "onSharePermissionReleased+${jsonEncode(map)}",
          toastLength: Toast.LENGTH_SHORT,
          gravity: ToastGravity.CENTER,
          backgroundColor: Colors.red,
          textColor: Colors.white,
          fontSize: 16.0
      );
    };
    EnxRtc.onSharePermissionDeny==(Map<dynamic, dynamic> map){
      Fluttertoast.showToast(
          msg: "onSharePermissionDeny+${jsonEncode(map)}",
          toastLength: Toast.LENGTH_SHORT,
          gravity: ToastGravity.CENTER,
          backgroundColor: Colors.red,
          textColor: Colors.white,
          fontSize: 16.0
      );
    };
    EnxRtc.onSharePermissionCanceled==(Map<dynamic, dynamic> map){
      Fluttertoast.showToast(
          msg: "onSharePermissionCanceled+${jsonEncode(map)}",
          toastLength: Toast.LENGTH_SHORT,
          gravity: ToastGravity.CENTER,
          backgroundColor: Colors.red,
          textColor: Colors.white,
          fontSize: 16.0
      );
    };
    EnxRtc.onSharePermissionGranted==(Map<dynamic, dynamic> map){
      Fluttertoast.showToast(
          msg: "onSharePermissionGranted+${jsonEncode(map)}",
          toastLength: Toast.LENGTH_SHORT,
          gravity: ToastGravity.CENTER,
          backgroundColor: Colors.red,
          textColor: Colors.white,
          fontSize: 16.0
      );
    };
    EnxRtc.onOutBoundCallSendDtmf==(Map<dynamic, dynamic> map){
      Fluttertoast.showToast(
          msg: "onOutBoundCallSendDtmf+${jsonEncode(map)}",
          toastLength: Toast.LENGTH_SHORT,
          gravity: ToastGravity.CENTER,
          backgroundColor: Colors.red,
          textColor: Colors.white,
          fontSize: 16.0
      );
    };
    EnxRtc.onDialStateEvent==(Map<dynamic, dynamic> map){
      Fluttertoast.showToast(
          msg: "onDialStateEvent+${jsonEncode(map)}",
          toastLength: Toast.LENGTH_SHORT,
          gravity: ToastGravity.CENTER,
          backgroundColor: Colors.red,
          textColor: Colors.white,
          fontSize: 16.0
      );
    };

  }
  void _setMediaDevice(String value) {
    Navigator.of(context, rootNavigator: true).pop();
    EnxRtc.switchMediaDevice(value);
  }

  createDialog() {
    showDialog(
        context: context,
        builder: (BuildContext context) {
          return AlertDialog(
            title: Text('Media Devices'),
            content: Column(
              mainAxisSize: MainAxisSize.min,
              children: <Widget>[
                Container(
                  height: 200, // Set a fixed height or adjust as needed
                  child: SingleChildScrollView(
                    child: Column(
                      children: deviceList.map((device) {
                        return ListTile(
                          title: Text(device.toString()),
                          onTap: () => _setMediaDevice(device.toString()),
                        );
                      }).toList(),
                    ),
                  ),
                )
              ],
            ),
          );
        }
    );
  }

  void _disconnectRoom() {
    EnxRtc.disconnect();
  }

  void knockKnock(){

  }
  void _spotLight(){
    EnxRtc.makeOutboundCall("919871498577", "12012774877");

  }

  void _toggleAudioEnergy() {
    if (isAudioEnergy) {
      EnxRtc.subscribeForTalkerNotification(false);
    } else {
      EnxRtc.subscribeForTalkerNotification(true);
    }
  }
  void _toggleAudio() {
    if (isAudioMuted) {
      EnxRtc.muteSelfAudio(false);
    //  EnxRtc.startLiveRecording({"urlDetails" : {}});
    } else {
      EnxRtc.muteSelfAudio(true);
     // EnxRtc.startLiveRecording({"urlDetails" : {}});
      // EnxRtc.muteSelfAudio(true);
    }
  }

  void _toggleVideo() {
    if (isVideoMuted) {
      EnxRtc.muteSelfVideo(false);

    } else {
      EnxRtc.muteSelfVideo(true);

    }
   // EnxRtc.requestSharePermission(EnxPubType.screen);

   // EnxRtc.sendDTMF("919871498577", "#123");

  }


  void _toggleSpeaker() async {
    List<dynamic> list = await EnxRtc.getDevices();
    setState(() {
      deviceList = list;
    });

    if(kIsWeb){
      Map<String, dynamic> device = convertMapToMap(list[0]) ;
      print("mic and  ${device["micList"]}");
      List<dynamic> micList = device["micList"];
      deviceList = micList.map((device) => device["label"]).toList();
      print("mic and  $deviceList");
    }

    createDialog();
  }
// Function to convert LinkedMap<Object?, Object?> to Map<String, dynamic>
  Map<String, dynamic> convertMapToMap(Map<Object?, Object?> map) {
    // Create an empty Map<String, dynamic>
    Map<String, dynamic> resultMap = {};

    // Iterate through the entries of the Map
    map.entries.forEach((entry) {
      // Check if the key is a String and value is dynamic
      if (entry.key is String && entry.value is dynamic) {
        // Add the entry to the resultMap with appropriate types
        resultMap[entry.key as String] = entry.value;
      } else {
        // Handle cases where the key is not a String or value is not dynamic
        // You can choose to skip these entries or handle them differently
        // For simplicity, we'll skip them in this example
      }
    });

    // Return the resulting Map<String, dynamic>
    return resultMap;
  }
  Future<dynamic> _toggleCamera() async{
    var camList=[];
    if(kIsWeb){

      List<dynamic> list = await EnxRtc.getDevices();
      Map<String, dynamic> device = convertMapToMap(list[0]) ;

     if(device['camList'].length==1){

       Fluttertoast.showToast(
           msg: "Only one camera available",
           toastLength: Toast.LENGTH_SHORT,
           gravity: ToastGravity.CENTER,
           backgroundColor: Colors.red,
           textColor: Colors.white,
           fontSize: 16.0
       );
     }else{
      await EnxRtc.switchCamera();

     }
    }else{
     await EnxRtc.switchCamera();
    }

  }

  int remoteView = -1;
   late List<dynamic> deviceList;

   Widget viewFlutter(int crossAxisCount){
     return kIsWeb?_buildWebGrid():_viewRows(crossAxisCount);
   }
  Widget _buildWebGrid() {
    // Web grid with 4 columns
    return GridView.builder(
      gridDelegate: const SliverGridDelegateWithFixedCrossAxisCount(
        crossAxisCount: 4,
        crossAxisSpacing: 4.0,
        mainAxisSpacing: 4.0,
      ),
      itemCount: _remoteUsers.length,
      itemBuilder: (BuildContext context, int index) {
        return  EnxPlayerWidget(_remoteUsers[index], local: false,mScalingType: ScalingType.SCALE_ASPECT_BALANCED,height: 400,
              width: 400);
      },
    );
  }
  Widget _viewRows(int crossAxisCount) {

    return GridView.count(
      crossAxisCount: crossAxisCount,
      crossAxisSpacing: 4.0,
      mainAxisSpacing: 4.0,

      childAspectRatio: 1.1,
      children: <Widget>[
        for (final widget in _renderWidget)
          SizedBox(
            height: MediaQuery.of(context).size.height,
            width: MediaQuery.of(context).size.width,
            child: widget
          ),

      ],
    );
  }

  List<Widget> renderStreamsGrid() {
    List<Widget> streamsExpanded = [];
    print("talkerList12:${_remoteUsers.length}");
    List<String> list1=["pankaj","pand","psd","sdf","dgsd","zdfgb"];
    streamsExpanded.addAll(list1
        .map(
          (entry) => Expanded(
        child: GestureDetector(
            onLongPress: () {
              // if( enxController.isLongPressEnable){
              //   enxController.streamId.value=entry.streamId!;
              //   enxController.annotationShare();
              //
              // }
            },
            child: Container(
              decoration:
              BoxDecoration(border: Border.all(color: Colors.grey)),
              child:Text('Pandey')
            )),
      ),
    )
        .toList());

    if (streamsExpanded.length > 2) {
      List<Widget> rows = [];

      for (var i = 0; i < streamsExpanded.length; i += 2) {
        var chunkEndIndex = i + 2;

        if (streamsExpanded.length < chunkEndIndex) {
          chunkEndIndex = streamsExpanded.length;
        }

        var chunk = streamsExpanded.sublist(i, chunkEndIndex);

        rows.add(
          Expanded(
            child: MediaQuery.of(context).orientation == Orientation.portrait
                ? Row(children: chunk)
                : Column(children: chunk),
          ),
        );
      }
      return rows;
    }

    return streamsExpanded;
  }

  Map<String, dynamic> oldActiveList = {};
  Map<String, dynamic> newActiveList = {};

  void updateActiveList(dynamic event) {
    // If the old active list is empty, set it to the new active list
    if (oldActiveList.isEmpty) {
      oldActiveList = Map.from(event);
      newActiveList = Map.from(event);
    } else {
      // Update the new active list
      event.forEach((newItem) {
        if (oldActiveList.containsKey(newItem['id'])) {
          // Update existing item
          newActiveList[newItem['id']] = newItem;
        } else {
          // Add new item
          newActiveList[newItem['id']] = newItem;
        }
      });

      // Remove items from the new active list that are not present in the new list
      newActiveList.removeWhere((key, value) =>
      !event.any((newItem) => newItem['id'] == key));

      // Set the old active list to the new active list
      oldActiveList = Map.from(newActiveList);
    }
  }

  Iterable<Widget> get _renderWidget sync* {
    for (final streamId in _remoteUsers) {
      // double width = MediaQuery.of(context).size.width;
      yield EnxPlayerWidget(streamId, local: false,mScalingType: ScalingType.SCALE_ASPECT_BALANCED,height: 50,
          width: 50);

    }
  }
  final _remoteUsers = <int>[];
  var _streamID = -1;


  @override
  Widget build(BuildContext context) {
    int playerWidth = MediaQuery.of(context).size.width.toInt();
    int playerHeight = MediaQuery.of(context).size.height.toInt();
    print(playerWidth);
    // Determine the platform
    final bool isMobile = MediaQuery.of(context).size.width < 600;

    // Define the number of columns based on the platform
    final int crossAxisCount = isMobile ? 2 : 4;
    return  Scaffold(
      body: SafeArea(
        child: Container(
          color: Colors.black,
          child: Stack(
            children: <Widget>[

               _remoteUsers.isNotEmpty ? Padding(
                 padding: const EdgeInsets.only(top:150.0),
                 child: viewFlutter(crossAxisCount),
               ): const Center(
                 child: Text(
                      'Waiting for some one to join',
                      style: TextStyle(color: Colors.redAccent,
                          fontWeight: FontWeight.w500,
                          fontSize: 20),
                    ),
               ),

              Align(
                alignment: Alignment.bottomCenter,
                child: Container(
                  color: Colors.white,
                  // height: 100,
                  width: MediaQuery.of(context).size.width,
                  child: Row(
                    children: [
                      SizedBox(
                        width: MediaQuery.of(context).size.width / 5,
                        child: MaterialButton(
                          onPressed: _toggleAudio,
                          child: isAudioMuted
                              ?const ImageIcon(AssetImage("assets/mute_audio.png"))

                              :const ImageIcon(AssetImage("assets/unmute_audio.png"))
                        ),
                      ),
                      SizedBox(
                        width: MediaQuery.of(context).size.width / 5,
                        child: MaterialButton(
                           onPressed: () async {
                            await _toggleCamera();
                          },
                          child: Image.asset(
                            'assets/camera_switch.png',
                            fit: BoxFit.cover,
                            height: 30,
                            width: 30,
                          ),
                        ),
                      ),
                      Container(
                        width: MediaQuery.of(context).size.width / 5,
                        child: MaterialButton(
                          onPressed: _toggleVideo,
                          child: isVideoMuted
                              ? Image.asset(
                            'assets/mute_video.png',
                            fit: BoxFit.cover,
                            height: 30,
                            width: 30,
                          )
                              : Image.asset(
                            'assets/unmute_video.png',
                            fit: BoxFit.cover,
                            height: 30,
                            width: 30,
                          ),
                        ),
                      ),
                      Container(
                        width: MediaQuery.of(context).size.width / 5,
                        child: MaterialButton(
                          onPressed: _toggleSpeaker,
                          child: Image.asset(
                            'assets/unmute_speaker.png',
                            fit: BoxFit.cover,
                            height: 30,
                            width: 30,
                          ),
                        ),
                      ),
                      Container(
                        width: MediaQuery.of(context).size.width / 5,
                        child: MaterialButton(
                          onPressed: _disconnectRoom,
                          child: Image.asset(
                            'assets/disconnect.png',
                            fit: BoxFit.cover,
                            height: 30,
                            width: 30,
                          ),
                        ),
                      ),

                    ],
                  ),
                ),
              ),
             kIsWeb?SizedBox(
               height: 140,
               width: 180,
               child: EnxPlayerWidget(0, local: true,width: 150, height: 150,mScalingType: ScalingType.SCALE_ASPECT_BALANCED),
             ): isConnected?SizedBox(
                height: 140,
                width: 180,
                child: EnxPlayerWidget(0, local: true,width: 150, height: 150,mScalingType: ScalingType.SCALE_ASPECT_BALANCED),
              ):Container(),
            ],
          ),
        ),
      ),
    );
  }
}

class ActiveList {
  bool active;
  List<ActiveListModel> activeList = [];
  String event;

  ActiveList(this.active, this.activeList, this.event);

  factory ActiveList.fromJson(Map<dynamic, dynamic> json) {
    return ActiveList(
      json['active'] as bool,
      (json['activeList'] as List).map((i) {
        return ActiveListModel.fromJson(i);
      }).toList(),
      json['event'] as String,
    );
  }
}

class ActiveListModel {
  String name;
  int streamId;
  String clientId;
  String videoaspectratio;
  String mediatype;
  bool videomuted;

  ActiveListModel(this.name, this.streamId, this.clientId,
      this.videoaspectratio, this.mediatype, this.videomuted);

  // convert Json to an exercise object
  factory ActiveListModel.fromJson(Map<dynamic, dynamic> json) {
    int sId = int.parse(json['streamId'].toString());
    return ActiveListModel(
      json['name'] as String,
      sId,
//      json['streamId'] as int,
      json['clientId'] as String,
      json['videoaspectratio'] as String,
      json['mediatype'] as String,
      json['videomuted'] as bool,
      // json['reason'] as String,
    );
  }
}
